=encoding utf8

=head1 NAME

Mail::Box::Maildir - handle Maildir folders

=head1 INHERITANCE

 Mail::Box::Maildir
   is a Mail::Box::Dir
   is a Mail::Box
   is a Mail::Reporter

=head1 SYNOPSIS

  use Mail::Box::Maildir;
  my $folder = Mail::Box::Maildir->new(folder => $ENV{MAIL}, ...);

=head1 DESCRIPTION

This documentation describes how Maildir mailboxes work, and what you
can do with the Maildir folder object C<Mail::Box::Maildir>.

Maildir is B<not supported for Windows>, because it create filenames
which are not accepted by the Windows system.

Extends L<"DESCRIPTION" in Mail::Box::Dir|Mail::Box::Dir/"DESCRIPTION">.

=head1 OVERLOADED

Extends L<"OVERLOADED" in Mail::Box::Dir|Mail::Box::Dir/"OVERLOADED">.

=over 4

=item overload: B<'""'> stringification

Inherited, see L<Mail::Box/"OVERLOADED">

=item overload: B<'@{}'> use as ARRAY

Inherited, see L<Mail::Box/"OVERLOADED">

=item overload: B<cmp> string comparison

Inherited, see L<Mail::Box/"OVERLOADED">

=back

=head1 METHODS

Extends L<"METHODS" in Mail::Box::Dir|Mail::Box::Dir/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Box::Dir|Mail::Box::Dir/"Constructors">.

=over 4

=item $class-E<gt>B<new>(%options)

Inherited, see L<Mail::Box/"Constructors">

 -Option           --Defined in     --Default
  accept_new                          false
  access             Mail::Box        'r'
  body_delayed_type  Mail::Box        Mail::Message::Body::Delayed
  body_type          Mail::Box        Mail::Message::Body::Lines
  coerce_options     Mail::Box        +[]
  create             Mail::Box        false
  directory          Mail::Box::Dir   <derived from folder name>
  extract            Mail::Box        10240
  field_type         Mail::Box        undef
  fix_headers        Mail::Box        false
  folder             Mail::Box        $ENV{MAIL}
  folderdir          Mail::Box        $ENV{HOME}/.maildir
  head_delayed_type  Mail::Box        Mail::Message::Head::Delayed
  head_type          Mail::Box        Mail::Message::Head::Complete
  keep_dups          Mail::Box        false
  lock_file          Mail::Box        <not used>
  lock_timeout       Mail::Box        <not used>
  lock_type          Mail::Box        'NONE' (constant)
  lock_wait          Mail::Box        <not used>
  locker             Mail::Box        undef
  manager            Mail::Box        undef
  message_type       Mail::Box        <folder-class>::Message
  multipart_type     Mail::Box        Mail::Message::Body::Multipart
  remove_when_empty  Mail::Box        true
  save_on_exit       Mail::Box        true
  trusted            Mail::Box        <depends on folder location>

=over 2

=item accept_new => BOOLEAN

When the folder is open, some messages may be stored in the C<new>
sub-directory.  By default, these messages are immediately moved to
the C<cur> directory when the folder is opened.  Otherwise, you have
to call L<acceptMessages()|Mail::Box::Maildir/"Internals"> or L<Mail::Box::Maildir::Message::accept()|Mail::Box::Maildir::Message/"Internals">.

=item access => $mode

=item body_delayed_type => CLASS

=item body_type => CLASS|CODE

=item coerce_options => ARRAY

=item create => BOOLEAN

=item directory => $directory

=item extract => INTEGER|CODE|METHOD|'LAZY'|'ALWAYS'

=item field_type => $class

=item fix_headers => BOOLEAN

=item folder => $name

=item folderdir => $directory

=item head_delayed_type => $class

=item head_type => $class

=item keep_dups => BOOLEAN

=item lock_file => $file

=item lock_timeout => $seconds

=item lock_type => $class|$name|\@names

=item lock_wait => $seconds

=item locker => $locker

=item manager => $manager

=item message_type => $class

=item multipart_type => CLASS

=item remove_when_empty => BOOLEAN

=item save_on_exit => BOOLEAN

=item trusted => BOOLEAN

=back

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Box::Dir|Mail::Box::Dir/"Attributes">.

=over 4

=item $obj-E<gt>B<fixHeaders>()

Inherited, see L<Mail::Box/"Attributes">

=item $obj-E<gt>B<folderdir>( [$directory] )

Inherited, see L<Mail::Box/"Attributes">

=item $obj-E<gt>B<isTrusted>()

Inherited, see L<Mail::Box/"Attributes">

=item $obj-E<gt>B<name>()

Inherited, see L<Mail::Box/"Attributes">

=item $obj-E<gt>B<removeEmpty>()

Inherited, see L<Mail::Box/"Attributes">

=item $obj-E<gt>B<type>()

Inherited, see L<Mail::Box/"Attributes">

=back

=head2 The folder

Extends L<"The folder" in Mail::Box::Dir|Mail::Box::Dir/"The folder">.

=over 4

=item $obj-E<gt>B<addMessage>($message, %options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<addMessages>(@messages)

Inherited, see L<Mail::Box/"The folder">

=item $class-E<gt>B<appendMessages>(%options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<close>(%options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<copyTo>($folder, %options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<delete>(%options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<directory>()

Inherited, see L<Mail::Box::Dir/"The folder">

=item $obj-E<gt>B<organization>()

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<size>()

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<update>(%options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<url>()

Inherited, see L<Mail::Box/"The folder">

=back

=head2 Folder flags

Extends L<"Folder flags" in Mail::Box::Dir|Mail::Box::Dir/"Folder flags">.

=over 4

=item $obj-E<gt>B<access>()

Inherited, see L<Mail::Box/"Folder flags">

=item $obj-E<gt>B<isModified>()

Inherited, see L<Mail::Box/"Folder flags">

=item $obj-E<gt>B<modified>( [BOOLEAN] )

Inherited, see L<Mail::Box/"Folder flags">

=item $obj-E<gt>B<writable>()

Inherited, see L<Mail::Box/"Folder flags">

=back

=head2 The messages

Extends L<"The messages" in Mail::Box::Dir|Mail::Box::Dir/"The messages">.

=over 4

=item $obj-E<gt>B<current>( [$number|$message|$message_id] )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<find>($message_id)

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<findFirstLabeled>( $label, [BOOLEAN, [\@msgs]] )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<message>( $index, [$message] )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<messageId>( $message_id, [$message] )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<messageIds>()

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<messages>( <'ALL'|$range|'ACTIVE'|'DELETED'|$label| !$label|$filter> )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<nrMessages>(%options)

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<scanForMessages>($message, $message_ids, $timespan, $window)

Inherited, see L<Mail::Box/"The messages">

=back

=head2 Sub-folders

Extends L<"Sub-folders" in Mail::Box::Dir|Mail::Box::Dir/"Sub-folders">.

=over 4

=item $any-E<gt>B<listSubFolders>(%options)

Inherited, see L<Mail::Box/"Sub-folders">

=item $any-E<gt>B<nameOfSubFolder>( $subname, [$parentname] )

Inherited, see L<Mail::Box/"Sub-folders">

=item $obj-E<gt>B<openRelatedFolder>(%options)

Inherited, see L<Mail::Box/"Sub-folders">

=item $obj-E<gt>B<openSubFolder>($subname, %options)

Inherited, see L<Mail::Box/"Sub-folders">

=item $any-E<gt>B<topFolderWithMessages>()

Inherited, see L<Mail::Box/"Sub-folders">

=back

=head2 Internals

Extends L<"Internals" in Mail::Box::Dir|Mail::Box::Dir/"Internals">.

=over 4

=item $obj-E<gt>B<acceptMessages>()

Accept all messages which are waiting in the C<new> directory to be
moved to the C<cur> directory.  This will not rescan the directory
for newly arrived messages, because that's a task for L<update()|Mail::Box/"The folder">.

=item $class-E<gt>B<appendMessage>(%options)

Z<>

=item $obj-E<gt>B<coerce>($message, %options)

Inherited, see L<Mail::Box/"Internals">

=item $any-E<gt>B<create>($foldername, %options)

[4.000] Returns the created directory.
Improves base, see L<Mail::Box/"Internals">

 -Option   --Defined in--Default
  folderdir  Mail::Box   undef

=over 2

=item folderdir => $directory

=back

=item $any-E<gt>B<createDirs>($folderdir)

The C<$folderdir> contains the absolute path of the location where the
messages are kept.  Maildir folders contain a C<tmp>, C<new>, and
C<cur> sub-directory within that folder directory as well.  This
method will ensure that all directories exist.
Returns C<false> on failure.

=item $obj-E<gt>B<determineBodyType>($message, $head)

Inherited, see L<Mail::Box/"Internals">

=item $any-E<gt>B<folderIsEmpty>($folderdir)

Checks whether the folder whose directory is specified as absolute C<$folderdir>
is empty or not.  A folder is empty when the C<tmp>, C<new>, and C<cur>
subdirectories are empty and some files which are left there by application
programs.  The maildir spec explicitly states: C<.qmail>, C<bulletintime>,
C<bulletinlock> and C<seriallock>.  If any other files are found, the
directory is considered not-empty.

=item $obj-E<gt>B<folderToDirectory>($foldername, $folderdir)

Inherited, see L<Mail::Box::Dir/"Internals">

=item $class-E<gt>B<foundIn>( [$foldername], %options )

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<lineSeparator>( [<STRING|'CR'|'LF'|'CRLF'>] )

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<locker>()

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<messageInFile>($filename)

Inherited, see L<Mail::Box::Dir/"Internals">

=item $obj-E<gt>B<read>(%options)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<readMessageFilenames>($directory)

Inherited, see L<Mail::Box::Dir/"Internals">

=item $obj-E<gt>B<readMessages>(%options)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<storeMessage>($message)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<toBeThreaded>($messages)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<toBeUnthreaded>($messages)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<updateMessages>(%options)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<write>(%options)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<writeMessages>()

Inherited, see L<Mail::Box/"Internals">

 -Option  --Defined in--Default
  messages  Mail::Box   <required>

=over 2

=item messages => ARRAY

=back

=back

=head2 Other methods

Extends L<"Other methods" in Mail::Box::Dir|Mail::Box::Dir/"Other methods">.

=over 4

=item $any-E<gt>B<timespan2seconds>($time)

Inherited, see L<Mail::Box/"Other methods">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Box::Dir|Mail::Box::Dir/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Box::Dir|Mail::Box::Dir/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Box/"Cleanup">

=back

=head1 DETAILS

The explanation is complicated, but for normal use you should bother
yourself with all details.

Extends L<"DETAILS" in Mail::Box::Dir|Mail::Box::Dir/"DETAILS">.

=head2 Different kinds of folders

Extends L<"Different kinds of folders" in Mail::Box::Dir|Mail::Box::Dir/"Different kinds of folders">.

=head2 Available folder types

Extends L<"Available folder types" in Mail::Box::Dir|Mail::Box::Dir/"Available folder types">.

=head2 Folder class implementation

Extends L<"Folder class implementation" in Mail::Box::Dir|Mail::Box::Dir/"Folder class implementation">.

=head2 How MAILDIR folders work

Maildir-type folders use a directory to store the messages of one folder.
Each message is stored in a separate file.  This seems useful, because
changes in a folder change only a few of these small files, in contrast with
file-based folders where changes in a folder cause rewrites of huge
folder-files.

However, Maildir based folders perform very bad if you need header information
of all messages.  For instance, if you want to have full knowledge about
all message-threads (see L<Mail::Box::Thread::Manager|Mail::Box::Thread::Manager>) in the folder, it
requires to read all header lines in all message files.  And usually, reading
your messages as threads is desired.  Maildir maintains a tiny amount
of info visible in the filename, which may make it perform just a little
bit faster than MH.

=head1 DIAGNOSTICS

=over 4

=item Error: Cannot append Maildir message in $new to folder $self.

The message (or messages) could not be stored in the right directories
for the Maildir folder.
Cast by C<appendMessage()>

=item Error: Cannot create Maildir message file $new.

A message is converted from some other message format into a Maildir format
by writing it to a file with a name which contains the status flags of the
message.  Apparently, creating this file failed.
Cast by C<coerce()>

=item Fault: Cannot create directory $dir: $!

Cast by C<appendMessage()>

=item Error: Folder $name is opened read-only

You can not write to this folder unless you have opened the folder to
write or append with L<new(access)|Mail::Box/"Constructors">, or the C<force> option is set C<true>.
Cast by C<write()>

=item Fault: cannot create Maildir directory $dir: $!

A Maildir folder is represented by a directory, with some sub-directories.  The
top folder directory could not be created for the reason indicated.
Cast by C<createDirs()>

=item Fault: cannot create Maildir subdir $dir: $!

Each Maildir folder has three sub-directories for administration: C<new>,
C<tmp>, and C<cur>.  The mentioned directory could not be created for
the indicated reason.
Cast by C<createDirs()>

=item Fault: cannot create directory $dir: $!

Cast by C<writeMessages()>

=item Fault: cannot create file $file: $!

Cast by C<writeMessages()>

=item Fault: cannot rename $from to $to: $!

Cast by C<writeMessages()>

=item Warning: changes not written to read-only folder $name.

You have opened the folder read-only --which is the default set
by L<new(access)|Mail::Box/"Constructors">--, made modifications, and now want to close it.
Set L<close(force)|Mail::Box/"The folder"> if you want to overrule the access mode, or close
the folder with L<close(write)|Mail::Box/"The folder"> set to C<NEVER>.
Cast by C<close()>

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=item Error: copying failed for one message.

For some reason, for instance disk full, removed by external process, or
read-protection, it is impossible to copy one of the messages.  Copying will
proceed for the other messages.
Cast by C<copyTo()>

=item Error: destination folder $name is not writable.

The folder where the messages are copied to is not opened with write
access (see L<new(access)|Mail::Box/"Constructors">).  This has no relation with write permission
to the folder which is controlled by your operating system.
Cast by C<copyTo()>

=item Warning: different messages with id $msgid.

The message id is discovered more than once within the same folder, but the
content of the message seems to be different.  This should not be possible:
each message must be unique.
Cast by C<messageId()>

=item Warning: folder $name not deleted: not writable.

The folder must be opened with write access via L<new(access)|Mail::Box/"Constructors">, otherwise
removing it will be refused.  So, you may have write-access according to
the operating system, but that will not automatically mean that this
C<delete> method permits you to.  The reverse remark is valid as well.
Cast by C<delete()>

=item Error: invalid timespan '$span'.

The string does not follow the strict rules of the time span syntax which
is permitted as parameter.
Cast by C<timespan2seconds()>

=item Warning: message-id '$msgid' does not contain a domain.

According to the RFCs, message-ids need to contain a unique random part,
then an C<@>, and then a domain name.  This is made to avoid the creation
of two messages with the same id.  The warning emerges when the C<@> is
missing from the string.
Cast by C<messageId()>

=item Error: no locking possible for maildir folders.

Cast by C<new()>

=item Error: unknown value to folder->close(write => $when).

Cast by C<close()>

=item Error: you cannot add a message which is already part of a folder to a new one.  Please use moveTo or copyTo.

Cast by C<addMessage()>

=back

=head1 SEE ALSO

This module is part of Mail-Box version 4.02,
built on April 10, 2026. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

